commit 35fe2fcda7c3e3682c468a7668168364353f10f6
Author: Mathieu Desnoyers <mathieu.desnoyers@efficios.com>
Date:   Thu Jul 11 09:40:01 2013 -0400

    Implement timeout for connect ipv4/ipv6
    
    Signed-off-by: Mathieu Desnoyers <mathieu.desnoyers@efficios.com>

diff --git a/src/common/sessiond-comm/Makefile.am b/src/common/sessiond-comm/Makefile.am
index 24063f8..72375c0 100644
--- a/src/common/sessiond-comm/Makefile.am
+++ b/src/common/sessiond-comm/Makefile.am
@@ -6,3 +6,4 @@ noinst_LTLIBRARIES = libsessiond-comm.la
 libsessiond_comm_la_SOURCES = sessiond-comm.c sessiond-comm.h \
                               unix.c unix.h inet.c inet.h inet6.c inet6.h \
                               relayd.h
+libsessiond_comm_la_LIBADD = -lrt
diff --git a/src/common/sessiond-comm/inet.c b/src/common/sessiond-comm/inet.c
index b2bd65d..6d72923 100644
--- a/src/common/sessiond-comm/inet.c
+++ b/src/common/sessiond-comm/inet.c
@@ -25,11 +25,18 @@
 #include <sys/types.h>
 #include <unistd.h>
 #include <errno.h>
+#include <fcntl.h>
+#include <time.h>
+#include <poll.h>
 
 #include <common/common.h>
 
 #include "inet.h"
 
+#define MSEC_PER_SEC	1000
+#define NSEC_PER_MSEC	1000000
+#define RECONNECT_DELAY	200	/* ms */
+
 /*
  * INET protocol operations.
  */
@@ -91,6 +98,130 @@ int lttcomm_bind_inet_sock(struct lttcomm_sock *sock)
 	return ret;
 }
 
+static
+int connect_no_timeout(struct lttcomm_sock *sock)
+{
+	return connect(sock->fd, (struct sockaddr *) &sock->sockaddr.addr.sin,
+			sizeof(sock->sockaddr.addr.sin));
+}
+
+/*
+ * Return time_a - time_b  in milliseconds.
+ */
+static
+unsigned long time_diff_ms(struct timespec *time_a,
+		struct timespec *time_b)
+{
+	time_t sec_diff;
+	long nsec_diff;
+	unsigned long result_ms;
+
+	sec_diff = time_a->tv_sec - time_b->tv_sec;
+	nsec_diff = time_a->tv_nsec - time_b->tv_nsec;
+
+	result_ms = sec_diff * MSEC_PER_SEC;
+	result_ms += nsec_diff / NSEC_PER_MSEC;
+	return result_ms;
+}
+
+static
+int connect_with_timeout(struct lttcomm_sock *sock)
+{
+	unsigned long timeout = lttcomm_get_network_timeout();
+	int ret, flags, connect_ret;
+	struct timespec orig_time, cur_time;
+
+	ret = fcntl(sock->fd, F_GETFL, 0);
+	if (ret == -1) {
+		PERROR("fcntl");
+		return -1;
+	}
+	flags = ret;
+
+	/* Set socket to nonblock */
+	ret = fcntl(sock->fd, F_SETFL, flags | O_NONBLOCK);
+	if (ret == -1) {
+		PERROR("fcntl");
+		return -1;
+	}
+
+	ret = clock_gettime(CLOCK_MONOTONIC, &orig_time);
+	if (ret == -1) {
+		PERROR("clock_gettime");
+		return -1;
+	}
+
+	connect_ret = connect(sock->fd,
+		(struct sockaddr *) &sock->sockaddr.addr.sin,
+		sizeof(sock->sockaddr.addr.sin));
+	if (connect_ret == -1 && errno != EAGAIN
+			&& errno != EWOULDBLOCK
+			&& errno != EINPROGRESS) {
+		goto error;
+	} else if (!connect_ret) {
+		/* Connect succeeded */
+		goto success;
+	}
+
+	/*
+	 * Perform poll loop following EINPROGRESS recommendation from
+	 * connect(2) man page.
+	 */
+	do {
+		struct pollfd fds;
+
+		fds.fd = sock->fd;
+		fds.events = POLLOUT;
+		fds.revents = 0;
+		ret = poll(&fds, 1, RECONNECT_DELAY);
+		if (ret < 0) {
+			goto error;
+		} else if (ret > 0) {
+			int optval;
+			socklen_t optval_len = sizeof(optval);
+
+			if (!(fds.revents & POLLOUT)) {
+				/* Either hup or error */
+				errno = EPIPE;
+				goto error;
+			}
+			/* got something */
+			ret = getsockopt(sock->fd, SOL_SOCKET,
+				SO_ERROR, &optval, &optval_len);
+			if (ret) {
+				goto error;
+			}
+			if (!optval) {
+				connect_ret = 0;
+				goto success;
+			} else {
+				goto error;
+			}
+		}
+		/* ret == 0: timeout */
+		ret = clock_gettime(CLOCK_MONOTONIC, &cur_time);
+		if (ret == -1) {
+			PERROR("clock_gettime");
+			connect_ret = ret;
+			goto error;
+		}
+	} while (time_diff_ms(&cur_time, &orig_time) < timeout);
+
+	/* Timeout */
+	errno = ETIMEDOUT;
+	connect_ret = -1;
+
+success:
+	/* Restore initial flags */
+	ret = fcntl(sock->fd, F_SETFL, flags);
+	if (ret == -1) {
+		PERROR("fcntl");
+		/* Continue anyway */
+	}
+error:
+	return connect_ret;
+}
+
 /*
  * Connect PF_INET socket.
  */
@@ -99,8 +230,11 @@ int lttcomm_connect_inet_sock(struct lttcomm_sock *sock)
 {
 	int ret, closeret;
 
-	ret = connect(sock->fd, (struct sockaddr *) &sock->sockaddr.addr.sin,
-			sizeof(sock->sockaddr.addr.sin));
+	if (lttcomm_get_network_timeout()) {
+		ret = connect_with_timeout(sock);
+	} else {
+		ret = connect_no_timeout(sock);
+	}
 	if (ret < 0) {
 		PERROR("connect");
 		goto error_connect;
diff --git a/src/common/sessiond-comm/inet6.c b/src/common/sessiond-comm/inet6.c
index 8d88374..52e2f8e 100644
--- a/src/common/sessiond-comm/inet6.c
+++ b/src/common/sessiond-comm/inet6.c
@@ -25,11 +25,18 @@
 #include <sys/types.h>
 #include <unistd.h>
 #include <errno.h>
+#include <fcntl.h>
+#include <time.h>
+#include <poll.h>
 
 #include <common/common.h>
 
 #include "inet6.h"
 
+#define MSEC_PER_SEC	1000
+#define NSEC_PER_MSEC	1000000
+#define RECONNECT_DELAY	200	/* ms */
+
 /*
  * INET protocol operations.
  */
@@ -91,6 +98,130 @@ int lttcomm_bind_inet6_sock(struct lttcomm_sock *sock)
 	return ret;
 }
 
+static
+int connect_no_timeout(struct lttcomm_sock *sock)
+{
+	return connect(sock->fd, (struct sockaddr *) &sock->sockaddr.addr.sin6,
+			sizeof(sock->sockaddr.addr.sin6));
+}
+
+/*
+ * Return time_a - time_b  in milliseconds.
+ */
+static
+unsigned long time_diff_ms(struct timespec *time_a,
+		struct timespec *time_b)
+{
+	time_t sec_diff;
+	long nsec_diff;
+	unsigned long result_ms;
+
+	sec_diff = time_a->tv_sec - time_b->tv_sec;
+	nsec_diff = time_a->tv_nsec - time_b->tv_nsec;
+
+	result_ms = sec_diff * MSEC_PER_SEC;
+	result_ms += nsec_diff / NSEC_PER_MSEC;
+	return result_ms;
+}
+
+static
+int connect_with_timeout(struct lttcomm_sock *sock)
+{
+	unsigned long timeout = lttcomm_get_network_timeout();
+	int ret, flags, connect_ret;
+	struct timespec orig_time, cur_time;
+
+	ret = fcntl(sock->fd, F_GETFL, 0);
+	if (ret == -1) {
+		PERROR("fcntl");
+		return -1;
+	}
+	flags = ret;
+
+	/* Set socket to nonblock */
+	ret = fcntl(sock->fd, F_SETFL, flags | O_NONBLOCK);
+	if (ret == -1) {
+		PERROR("fcntl");
+		return -1;
+	}
+
+	ret = clock_gettime(CLOCK_MONOTONIC, &orig_time);
+	if (ret == -1) {
+		PERROR("clock_gettime");
+		return -1;
+	}
+
+	connect_ret = connect(sock->fd,
+		(struct sockaddr *) &sock->sockaddr.addr.sin6,
+		sizeof(sock->sockaddr.addr.sin6));
+	if (connect_ret == -1 && errno != EAGAIN
+			&& errno != EWOULDBLOCK
+			&& errno != EINPROGRESS) {
+		goto error;
+	} else if (!connect_ret) {
+		/* Connect succeeded */
+		goto success;
+	}
+
+	/*
+	 * Perform poll loop following EINPROGRESS recommendation from
+	 * connect(2) man page.
+	 */
+	do {
+		struct pollfd fds;
+
+		fds.fd = sock->fd;
+		fds.events = POLLOUT;
+		fds.revents = 0;
+		ret = poll(&fds, 1, RECONNECT_DELAY);
+		if (ret < 0) {
+			goto error;
+		} else if (ret > 0) {
+			int optval;
+			socklen_t optval_len = sizeof(optval);
+
+			if (!(fds.revents & POLLOUT)) {
+				/* Either hup or error */
+				errno = EPIPE;
+				goto error;
+			}
+			/* got something */
+			ret = getsockopt(sock->fd, SOL_SOCKET,
+				SO_ERROR, &optval, &optval_len);
+			if (ret) {
+				goto error;
+			}
+			if (!optval) {
+				connect_ret = 0;
+				goto success;
+			} else {
+				goto error;
+			}
+		}
+		/* ret == 0: timeout */
+		ret = clock_gettime(CLOCK_MONOTONIC, &cur_time);
+		if (ret == -1) {
+			PERROR("clock_gettime");
+			connect_ret = ret;
+			goto error;
+		}
+	} while (time_diff_ms(&cur_time, &orig_time) < timeout);
+
+	/* Timeout */
+	errno = ETIMEDOUT;
+	connect_ret = -1;
+
+success:
+	/* Restore initial flags */
+	ret = fcntl(sock->fd, F_SETFL, flags);
+	if (ret == -1) {
+		PERROR("fcntl");
+		/* Continue anyway */
+	}
+error:
+	return connect_ret;
+}
+
 /*
  * Connect PF_INET socket.
  */
@@ -99,8 +230,11 @@ int lttcomm_connect_inet6_sock(struct lttcomm_sock *sock)
 {
 	int ret, closeret;
 
-	ret = connect(sock->fd, (struct sockaddr *) &sock->sockaddr.addr.sin6,
-			sizeof(sock->sockaddr.addr.sin6));
+	if (lttcomm_get_network_timeout()) {
+		ret = connect_with_timeout(sock);
+	} else {
+		ret = connect_no_timeout(sock);
+	}
 	if (ret < 0) {
 		PERROR("connect inet6");
 		goto error_connect;